do
   local MyUnitIdTable = {
      'raa0205',
      'rea0205',
      'rra0205',
      'rrs0203',
      'ras0203',
      'res0203',
      'ral0107',
      'rel0107',
      'rrl0107',
      'rel0305',
      'ral0305',
      'rrs0306',
      'rrl0305',
      'res0301',
      'ral0306',
      'rrl0306',
      'rel0306',
      'ral0307',
      'rel0307',
      'rel0308',
      'rel0309',
      'rel0310',
      'rrl0307',
      'rrl0308',
      'rrl0204',
      'rrl0309',
      'ral0204',
      'ral0308',
      'ral0309',
      'ral0310',
      'ral0311',
      'raa0206',
      'rea0306',
      'rel0311',
      'rra0206',
      'rrl0310',
   }
   local oldFileNameFn = GetUnitIconFileNames
   
   local function IsMyUnit(blueprint)
      for i, v in MyUnitIdTable do
         if v == blueprint.Display.IconName then
            return true
         end
      end
      return false
   end
   
   function GetUnitIconFileNames(blueprint)
      if IsMyUnit(blueprint) then
          local iconName = "/mods/Reds Unit Pack/icons/units/" .. blueprint.Display.IconName .. "_icon.dds"
          local upIconName = "/mods/Reds Unit Pack/icons/units/" .. blueprint.Display.IconName .. "_build_btn_up.dds"
          local downIconName = "/mods/Reds Unit Pack/icons/units/" .. blueprint.Display.IconName .. "_build_btn_down.dds"
          local overIconName = "/mods/Reds Unit Pack/icons/units/" .. blueprint.Display.IconName .. "_build_btn_over.dds"
         
          if DiskGetFileInfo(iconName) == false then
            WARN('Blueprint icon for unit '.. blueprint.Display.IconName ..' could not be found, check your file path and icon names!')
              iconName = '/textures/ui/common/icons/units/default_icon.dds'
          end
         
          if DiskGetFileInfo(upIconName) == false then
              upIconName = iconName
          end

          if DiskGetFileInfo(downIconName) == false then
              downIconName = iconName
          end

          if DiskGetFileInfo(overIconName) == false then
              overIconName = iconName
          end
         
          return iconName, upIconName, downIconName, overIconName
      else
         return oldFileNameFn(blueprint)
      end
   end
end