local EffectTemplate = import('/lua/EffectTemplates.lua')
local TSeaUnit = import('/lua/terranunits.lua').TSeaUnit
local WeaponFile = import('/lua/terranweapons.lua')
local TIFCruiseMissileLauncher = WeaponFile.TIFCruiseMissileLauncher

RES0301 = Class(TSeaUnit) {
    DestructionTicks = 200,

    Weapons = {
       
        CruiseMissile = Class(TIFCruiseMissileLauncher) {
                CurrentRack = 1,
           
                PlayFxMuzzleSequence = function(self, muzzle)
                    local bp = self:GetBlueprint()
                    self.Rotator = CreateRotator(self.unit, bp.RackBones[self.CurrentRack].RackBone, 'y', nil, 90, 90, 90)
                    muzzle = bp.RackBones[self.CurrentRack].MuzzleBones[1]
                    self.Rotator:SetGoal(90)
                    TIFCruiseMissileLauncher.PlayFxMuzzleSequence(self, muzzle)
                    WaitFor(self.Rotator)
                    WaitSeconds(1)
                end,
                
                CreateProjectileAtMuzzle = function(self, muzzle)
                    muzzle = self:GetBlueprint().RackBones[self.CurrentRack].MuzzleBones[1]
                    if self.CurrentRack >= 8 then
                        self.CurrentRack = 1
                    else
                        self.CurrentRack = self.CurrentRack + 1
                    end
                    TIFCruiseMissileLauncher.CreateProjectileAtMuzzle(self, muzzle)
                end,
                
                PlayFxRackReloadSequence = function(self)
                    WaitSeconds(1)
                    self.Rotator:SetGoal(0)
                    WaitFor(self.Rotator)
                    self.Rotator:Destroy()
                    self.Rotator = nil
                end,
            },
    },

    RadarThread = function(self)
        local spinner = CreateRotator(self, 'Spinner04', 'x', nil, 0, 30, -45)
        while true do
            WaitFor(spinner)
            spinner:SetTargetSpeed(-45)
            WaitFor(spinner)
            spinner:SetTargetSpeed(45)
        end
    end,

    OnStopBeingBuilt = function(self, builder,layer)
        TSeaUnit.OnStopBeingBuilt(self, builder,layer)
        self:ForkThread(self.RadarThread)
        self.Trash:Add(CreateRotator(self, 'Spinner01', 'y', nil, 45, 0, 0))
        self.Trash:Add(CreateRotator(self, 'Spinner03', 'y', nil, -30, 0, 0))
    end,

}

TypeClass = RES0301
