local CLandUnit = import('/lua/cybranunits.lua').CLandUnit
local CybranWeaponsFile = import('/lua/cybranweapons.lua')
local CDFElectronBolterWeapon = CybranWeaponsFile.CDFElectronBolterWeapon

RRL0204 = Class(CLandUnit) {

    Weapons = {
        Bolter = Class(CDFElectronBolterWeapon) {
            SphereEffectIdleMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere01_mesh',
            SphereEffectActiveMesh = '/effects/entities/cybranphalanxsphere01/cybranphalanxsphere02_mesh',
            SphereEffectBp = '/effects/emitters/zapper_electricity_01_emit.bp',

            OnCreate = function(self)
                CDFElectronBolterWeapon.OnCreate(self)

                self.SphereEffectEntity = import('/lua/sim/Entity.lua').Entity()
                self.SphereEffectEntity:AttachBoneTo(-1,self.unit,'ORB')
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
                self.SphereEffectEntity:SetDrawScale(0.6)
                self.SphereEffectEntity:SetVizToAllies('Intel')
                self.SphereEffectEntity:SetVizToNeutrals('Intel')
                self.SphereEffectEntity:SetVizToEnemies('Intel')                  
                local emit = CreateAttachedEmitter(self.unit,'ORB',self.unit:GetArmy(),self.SphereEffectBp)

                self.unit.Trash:Add(self.SphereEffectEntity)
                self.unit.Trash:Add(emit)
            end,

            IdleState = State (CDFElectronBolterWeapon.IdleState) {
                Main = function(self)
                    CDFElectronBolterWeapon.IdleState.Main(self)
                end,
                
                OnGotTarget = function(self)
                    CDFElectronBolterWeapon.OnGotTarget(self)
                    self.SphereEffectEntity:SetMesh(self.SphereEffectActiveMesh)
                end,                
            },

            OnLostTarget = function(self)
                CDFElectronBolterWeapon.OnLostTarget(self)
                self.SphereEffectEntity:SetMesh(self.SphereEffectIdleMesh)
            end,        
        },
    },
    OnStopBeingBuilt = function(self,builder,layer)
        CLandUnit.OnStopBeingBuilt(self,builder,layer)
        self:HideBone('Turret_Muzzle', false)
    end,    
    
}
TypeClass = RRL0204